%!TEX root=../../../thesis.tex
%!TEX file=content/appendix/solving-daes/numerical-integrators.tex

\section{Numerical Integrators for Mechanical Systems}\label{sec:appendix:solving-daes:mechanical-systems}

Conventionally, one may use any integrator for first-order \acrshort{DAE} as long as they can handle singular mass matrices~$\Mass$\footnote{Singular mass matrices emerge with the matrix formulation of a \acrshort{DAE} where the mass matrix rank decreases and as such the matrix cannot be inverted.}.
This can very often be achieved by implicit solvers\footnote{In MATLAB \texttt{ode15s} for linearly implicit systems~(see~\cref{eqn:app:solving-daes:constrained-dae-vector-matrix}) and \texttt{ode15i} for fully implicit systems.}, however, one needs to to take into account the system's specificity.
Since commercially available solvers generally integrate a first-order \acrshort{ODE} using a variable step size, their error bounds\textemdash both absolute and relative error on the forward integrated state\textemdash can be very restrictive and do not consider the physical quantities of the states.
A cogent example may be given when considering a system with two translation and one rotational \acrshort{DOF}.
Generally, rotations are parametrized in radian, the rate of change of which may be significantly larger than that of translational states parametrized in meter.
With a constrained mechanical system, the free body's dynamics are impacted by the constraint forces which generally are a function of the state of the system.
Since the constraint forces / Lagrange multipliers are now part of the state of integration, their rate of change is tracked by the solver's error calculation.
However, there usually is no need to bound errors on the constraint forces as we would want them to be unconstrained in that sense as that they will always make sure the constraints are satisfied.

It may be possible to separately specify bounds of constraint forces states, however, the rate of change of these states will always be monitored by the solver eventually leading to termination of integration when bounds can no longer be satisfied, not even with decreasing step size.
If the mechanical system now also is governed by nonholonomic constraints, then the impact of error-bound controlled variable step-size solvers becomes more prominent.
To the rescue come integrators that are not based on pure mathematics of differential equations, but are based on meta knowledge from the mechanical system under integration.
In principle, since we are concerned with integrating a mechanical system which we have obtained from either Newton-Euler's method, Lagrangian mechanics, or Hamiltonian dynamics, we can integrate properties like energy and momentum conservation into the integration process.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\input{content/appendix/solving-daes/numerical-integrators/leapfrog}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\input{content/appendix/solving-daes/numerical-integrators/betsch}
